#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

#include "_gen.c"

int Cursor = 0;
char FileName[64];

static char *Colours[] = { "Black","Blue","Green","Cyan","Red","Purple","Yellow","White" };

int ColToInt(unsigned long l)
{
int r = 0;
if (l & 0x1) r=r+1;
if (l & 0x100) r=r+2;
if (l & 0x10000L) r=r+4;
return(r);
}

void LoadDefaults(void)
{
int i;
for (i = 0;i < CCountAll();i++)
			CPut(i,CGetDefault(i));
}

void Refresh(int p,int i)
{
int x,y;
char s[16];
x = (p / 20) * 26+1;y = (p % 20)+ 3;
gotoxy(x,y);
textcolor(BLUE);textbackground(LIGHTGRAY);
cprintf("[         ]");
gotoxy(x+1,y);
textbackground((p == Cursor) ? RED:BLACK);
strcpy(s,"???");
textcolor(YELLOW);
switch(CGetType(i))
	{
	case '#':	sprintf(s,"%ld",CGet(i));break;
	case '$':	sprintf(s,"Code $%lx",CGet(i));break;
	case '@':	sprintf(s,"%s",Colours[ColToInt(CGet(i))],CGet(i));break;
	case 'b':	strcpy(s,CGet(i) ? "True" : "False");break;
	case 'c':   sprintf(s,"%07lX_%X",
						(CGet(i) >> 4) & 0xFFFFFFFL,
						(CGet(i) & 0xF));break;
	case 'x':	strcpy(s,"<system>");break;
	}
cprintf("%-9s",s);
gotoxy(x+12,y);
textbackground(LIGHTGRAY);
textcolor(BLACK);
cprintf(CGetText(i),CGet(i));
gotoxy(x+2+strlen(s),y);
}

void RefreshAll(void)
{
int i;
char Banner[90];
textbackground(LIGHTGRAY);
clrscr();
gotoxy(1,1);textbackground(RED);textcolor(YELLOW);
cprintf("%80s","");
sprintf(Banner,"Gameboy 97 Configuration File Editor - %s",FileName);
gotoxy(40-strlen(Banner)/2,1);cprintf("%s",Banner);
for (i = 0;i < CCount();i++) Refresh(i,CX(i));
}

void Handler(int p,int n,int Key)
{
int n1;
unsigned long l1;
switch(CGetType(n))
	{
	case 'b':	if (Key >= 32) CPut(n,1-CGet(n));
				break;

	case 'c':	if (Key == 8) CPut(n,CGet(n)/16);
				if (isxdigit(Key) && Key > 0 && CGet(n) <= 0xFFFFFFFL)
					{
					Key = toupper(Key);
					if (Key > 58) Key = Key-7;
					l1 = CGet(n)*16L+(long)(Key-48);
					CPut(n,l1);
					}
				break;

	case '$':	if (Key == 8) CPut(n,CGet(n)/16);
				if (isxdigit(Key) && Key > 0)
					{
					Key = toupper(Key);
					if (Key > 58) Key = Key-7;
					n1 = (int)CGet(n)*16+Key-48;
					if (n1 < 256) CPut(n,n1);
					}
				break;

	case '@':	if (Key == 32)
					{
					n1 = (ColToInt(CGet(n))+1) & 7;
					if (n1 == 0) n1 = 1;
					l1 = 0L;
					if (n1 & 4) l1 += 0xFF0000L;
					if (n1 & 2) l1 += 0xFF00L;
					if (n1 & 1) l1 += 0xFFL;
					CPut(n,l1);
					}
				break;

	case '#':	if (Key == 8) CPut(n,CGet(n)/10);
				if (Key >= 48 && Key < 58)
					{
					n1 = (int)CGet(n)*10+Key-48;
					if (n1 < 1000) CPut(n,n1);
					}
				break;
	}
Refresh(p,n);
}

void main(int argc,char *argv[])
{
int i,n;
FILE *f;
char *p;
strcpy(FileName,"Default.G97");
if (argc == 2)
	{
	strcpy(FileName,argv[1]);
	p = strchr(FileName,'.');
	if (p != NULL) *p = '\0';
	strcat(FileName,".g97");
	}
strlwr(FileName);

LoadDefaults();							/* Load in the default values */

if (f = fopen("Default.G97","rb"),f != NULL)
	{
	fread(&CFG,sizeof(struct ConfigStruct),1,f);
	fclose(f);
	}

f = fopen(FileName,"rb");
if (f != NULL)
	{
	fread(&CFG,sizeof(struct ConfigStruct),1,f);
	fclose(f);
	}

RefreshAll();
Refresh(Cursor,CX(Cursor));
do
	{
	i = getch();						/* Get keystroke */
	if (i == 0) i = -getch();
	if (i == -72 || i == -80)			/* Up or down */
		{
		if (CValidate(CX(Cursor),CGet(CX(Cursor))))		/* Check validation */
			{
			n = Cursor;
			Cursor = Cursor + (i == -72 ? -1 : 1);
			if (Cursor < 0) Cursor = CCount()-1;
			if (Cursor >= CCount()) Cursor = 0;
			Refresh(n,CX(n));
			Refresh(Cursor,CX(Cursor));
			}
		else                    		/* failed,beep and don't move */
			{
			sound(440);
			delay(400);
			nosound();
			}
		}
	else
		Handler(Cursor,CX(Cursor),i);
	if (i == 27)
		if  (!CValidate(CX(Cursor),CGet(CX(Cursor))))
			{
			sound(440);
			delay(400);
			nosound();
			i = 0;
			}
	}
while (i != 27);
textbackground(BLACK);textcolor(WHITE);clrscr();

f = fopen(FileName,"wb");
fwrite(&CFG,sizeof(struct ConfigStruct),1,f);
fclose(f);
}